package com.csc349blum.statecapitalquiz;

import java.io.InputStream;
import java.util.Random;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.os.Bundle;
import android.app.Activity;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {

	//JSON Object and Array declared globally
	JSONObject myJSON_object;
	JSONArray myJSON_array;
	
	//array of integers used to get a random arrangement of state objects 
	//shuffle this array instead of the 
	int[] indexArray;
	
	//array of id's for the 5 TextViews
	int[] tv_ids = {R.id.tvState0, R.id.tvState1, R.id.tvState2, R.id.tvState3, R.id.tvState4};
	
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		//read JSON file as shown previously
		try{
			//http://stackoverflow.com/questions/6420293/reading-android-raw-text-file
			InputStream is = getResources().openRawResource(R.raw.states_info);
		    byte[] buffer = new byte[is.available()];
		    while (is.read(buffer) != -1);
		    
		    String myText = new String(buffer);
			
		    //http://stackoverflow.com/questions/9605913/how-to-parse-json-in-android
		    //extract the main (top-level) JSON object from the file read above
		    myJSON_object = new JSONObject(myText);
		    
		    //the main JSON object is/includes an array called employees
		    //extract that array
		    myJSON_array = myJSON_object.getJSONArray("states");
		    
		    //make indexArray the same size as the JSON Array
		    //assign it values starting at 0
		    indexArray = new int[myJSON_array.length()];
		    for(int i=0; i<indexArray.length; i++){
		    	indexArray[i]=i;
		    }
		}
		catch(Exception e){
			Toast.makeText(getBaseContext(), "Problem with file", Toast.LENGTH_SHORT).show();
			e.printStackTrace();
		}  
		
	    startQuiz();
		
	}//end onCreate
	
	//**********************************************************************************************
	public void startQuiz(){
		
		
		//shuffle index Array
		int i; 
		int j;
		int swap;
		Random rnd = new Random();

		for(i=0; i< indexArray.length; i++){
			j = rnd.nextInt(indexArray.length);
			swap = indexArray[i];
			indexArray[i]=indexArray[j];
			indexArray[j]= swap;
		}
		
		
		//get state name from JSON array and put shuffled state names in Edit Texts 
	    for (i=0; i < 5; i++){
	    	try{
	    		//get an individual element of the JSON array
	    		JSONObject aJSON_element = myJSON_array.getJSONObject(indexArray[i]);
	    		//get the individual properties of the JSON element
	    		String state = aJSON_element.getString("stateName");
	    		String capital = aJSON_element.getString("stateCapital");
	    		
	    		//int myId = getResources().getIdentifier("tvState"+i, "layout", getPackageName());
	    		
	    		//Toast.makeText(getBaseContext(), Integer.toString(myId), Toast.LENGTH_SHORT).show();
	    		//Toast.makeText(getBaseContext(), Integer.toString(R.id.tvState0), Toast.LENGTH_SHORT).show();
	    		
	    		TextView myTextView = (TextView) findViewById(tv_ids[i]) ;
	    		myTextView.setText(state);
	    		
	       		
	    	}
	    	catch (JSONException e) 
	    	{
	    		Toast.makeText(getBaseContext(), "Dude, you have to know what the JSON looks like to parse it", Toast.LENGTH_SHORT).show();
	    		e.printStackTrace();
	    	}
	    }
		
	}
	
	
	
	
} //end class
